
package softparsmap;


import ooc.*;

/**
 * Extending this class will facilitate creating a tag instance
 * that is needed for any class to be installed and used by the
 * property file. 
 */
public abstract class AbstractEdgeType extends LinkedTagInstance
    implements EdgeType {

    private double _defaultNodeEdge;
    private double _defaultLeafEdge;

    public void setupInstance() {
	super.setupInstance();
	_defaultNodeEdge = getAttributeDouble("default_node_edge_value");
	_defaultLeafEdge = getAttributeDouble("default_leaf_edge_value");
    }

    public PropertyFile getPropertyFile() {
	return (PropertyFile)getTag().getContainer();
    }

    public double getDefaultNodeEdge() {
	return _defaultNodeEdge;
    }

    
    public double getDefaultLeafEdge() {
	return _defaultLeafEdge;
    }
    
}
