
package softparsmap;


import ooc.*;

/**
 * Extending this class will facilitate creating a tag instance
 * that is needed for any class to be installed and used by the
 * property file. 
 */
public abstract class AbstractFamilyGroup extends LinkedTagInstance
    implements FamilyGroup {

    public PropertyFile getPropertyFile() {
	return (PropertyFile)getTag().getContainer();
    }

    /**
     * Returns the name of the family group which is
     * the value in the did attribute in the tag.
     *
     * @return the value in the did attribute
     */ 
    public String getGroupName() {
	return getAttributeString("did");
    }
    
    public DataSource getDataSource() {
	return (DataSource)getAttribute("data_source");
    }
    
    /*
    public Inparalogous getInparalogous() {
	return getPropertyFile()
	    .getInparalogous(getAttribute("inparalogous"));
    }
    */

        
}

