
package softparsmap;


import java.io.*;
import java.nio.charset.Charset;

/**
 * This class makes it easier to write data to file using a
 * specified charset.
 */
public class CharsetFileWriter extends Writer {

    private Writer writer = null;

    public CharsetFileWriter(String fileName) throws IOException {
	this(new File(fileName));
    }
   
    public CharsetFileWriter(File file) throws IOException {
	this(file, "ISO-8859-1");
    	//this(file, (Charset)Charset.availableCharsets().get("ISO-8859-1"));
    }
    
    public CharsetFileWriter(File file, String charset) throws IOException {
	FileOutputStream fos = new FileOutputStream(file);
	OutputStreamWriter osw =new OutputStreamWriter(fos, charset);
	this.writer = new BufferedWriter(osw);
    }

    public void close() throws IOException {
	this.writer.close();
    }

    public void flush() throws IOException {
	this.writer.flush();
    }
    
    public void write(char[] cbuf) throws IOException {
	this.writer.write(cbuf);
    }

    public void write(char[] cbuf, int off, int len) throws IOException {
	this.writer.write(cbuf,off,len);
    }

    public void write(int c) throws IOException {
	this.writer.write(c);
    }

    public void write(String str) throws IOException {
	this.writer.write(str);
    }

    public void write(String str, int off, int len) throws IOException {
	this.writer.write(str,off,len);
    }

}

