
package softparsmap;


import java.util.*;

/**
 * This set is used as child set for gene trees and as well
 * as for species trees. It is a simple set that uses limited
 * resources.
 */
public class ChildSet extends Vector implements Set {

    /**
     * Construct an empty child set.
     */
    public ChildSet() {
	super();
    }

    /**
     * Set the start capacity.
     *
     * @param cap is the start capacity. 
     */
    public ChildSet(int cap) {
	super(cap);
    }

    /**
     * Adding an object. A set can only contain one unique object.
     *
     * @param o is the object that will be added if it does
     *   not already exists in the set.
     * @return true if the set was altered
     */
    public boolean add(Object o) {
	if(super.contains(o)) {
	    return false;
	} else {
	    return super.add(o);
	}
    }
}
