
package softparsmap;


import java.util.*;

/**
 * Will print the numbers of the family group. The numbers are
 * printed in order.
 */
public class ComputeFamilyNumbers extends ComputeFamilyGroup {
    
    private Set _familyNumbers = null;

    /**
     * Creating the set where all family numbers are stored.
     *
     * @param verbose does nothing.
     */
    public void beforeCompute(boolean verbose) {
	_familyNumbers = new TreeSet();
    }

    /**
     * Store the family number in the set.
     *
     * @param family is the family that will be computed
     * @param verbose is true if extra information is printed
     * @throws Throwable because exceptions are logged for every family
     *         but the task will continue on the rest of the family group.
     */
    public void computeFamily(Family family, boolean verbose)
	throws Throwable {
	_familyNumbers.add(family.getFamilyNumber());
    }

    /**
     * Prints the set with family numbers.
     *
     * @param verbose does nothing
     */
    public void afterCompute(boolean verbose) {
	System.out.println(_familyNumbers);
    }
    
}
