
package softparsmap;


import java.io.*;
import java.util.*;

/**
 * Index for data source {@link DataSourceXmlNcbiTaxonomy}. 
 */
public class DataSourceIndexXmlNcbiTaxonomy implements Serializable {

    /**
     * This map contain the tree and is created from the file nodes.dmp.
     * The key and value is tax id's in Integer class. The key is the
     * tax id of the child and the value is the tax value of the parent.
     */
    public Map childToParent;

    
    /**
     *  A map from NCBI's tax id's (Integer) to file pointer into
     *  the file names.dmp such that when reading one line from that
     *  position will get the name row for that species.
     */
    public Map nodesIdToNamesFilePointer;

    
    /**
     *  A map from NCBI's tax id numbers (Integer) to a file pointers (Long)
     *  into the file nodes.dmp such that when reading one line from
     *  that position will get the name nodes for that species.
     */
    //public Map nodesIdToNodesFilePointer;

    
    /**
     *  A map from the database id number (Integer) to the tax id number in
     *  NCBI (Integer).
     */
    public Map databaseIdToNodesId;

    /**
     *  A map from the database id numbers (Integer) to a position 
     *  (FilePointerPart) in the database that holds the sequence part.
     */
    public Map databaseIdToFilePointerPart;

    /**
     * Constructor creates empty maps.
     */
    public DataSourceIndexXmlNcbiTaxonomy() {
	childToParent = new Hashtable();
	nodesIdToNamesFilePointer = new Hashtable();
	//nodesIdToNodesFilePointer = new Hashtable();
	databaseIdToNodesId = new Hashtable();
	databaseIdToFilePointerPart = new Hashtable();
    }

}
