package softparsmap;


import ooc.*;
import java.util.*;
import java.io.*;


public class FamilyGroupTreesInFilesInfoPerRow 
    extends FamilyGroupTreesInFiles {

    public GeneNode getGeneTree(Integer familyNumber) {
	// getting rows
	List rows = new Vector();
	try {
	    File gf = (File)getNumberToFileMap().get(familyNumber);
	    BufferedReader br = new BufferedReader(new FileReader(gf));
	    String line = br.readLine();
	    while (line!=null) {
		rows.add(line.trim());
		line = br.readLine();
	    }
	} catch(Exception e) {
	    throw new FatalException(e);
	}
	// parsing tree
	TreeParser tpMain = (TreeParser)getAttribute("tree_parser_in");
	String treeRowStartWith = 
	    getAttributeString("tree_structure_row_starts_with");
	GeneNode tree = (GeneNode)
	    tpMain.parseIn(getRow(rows, treeRowStartWith));
	// adding tree information
	Tag rowParserTag = getContainer().getTag("tree_parser::row");
	for (Iterator i = getChildIteratorByName("tree_parser");i.hasNext();) {
	    Tag tpTag = (Tag)i.next();
	    TreeParser tpRow = (TreeParser)tpTag.getTagInstance();
	    if (!tpTag.extending(rowParserTag)) {
		throw new FatalException("Parser "+tpTag.getTagRef()+
					 " must extend tag "+rowParserTag);
	    }
	    String rowStartsWith = tpTag.getAttributeString("row_starts_with");
	    tpRow.parseIn(tree, getRow(rows, rowStartsWith));
	}
	// replacing leaf labels with 
	if (hasAttributeValue("labels_key")) {
	    String labelsKey = getAttributeString("labels_key");
	    for (Iterator i = tree.getLeaves().iterator();i.hasNext();) {
		Node leaf = (Node)i.next();
		String newLabel = (String)leaf.getMap().get(labelsKey);
		if (newLabel==null) {
		    throw new FatalException
			("Tag "+getTagRef()+": Could not find key="+labelsKey+
			 " in map "+leaf.getMap());
		}
		leaf.setLabel(Integer.parseInt(newLabel));
	    }
	}
	//
	return tree;
    }

    private String getRow(List rows, String treeRowStartWith) {
	for (Iterator i = rows.iterator();i.hasNext();) {
	    String row = (String)i.next();
	    if (row.indexOf(treeRowStartWith)==0) {
		return row;
	    }
	}
	throw new FatalException("Tag "+getTagRef()+": Could not find a row "+
				 "which starts with "+treeRowStartWith);
    }

}
