
package softparsmap;


import java.lang.*;
import java.util.*;

/**
 * A fatal exception. When this is thrown the execution can not
 * continue. However, when running a task on a family group the
 * execution on the family will halt but the task will continue
 * with the next family from the family group.
 */
public class FatalException extends RuntimeException {

    /**
     *  This exception is caused by a deeper one.
     */
    protected FatalException(Throwable e) {
	super(e);
    }

    /**
     *  Should only be used when debugging.
     */
    protected FatalException() {
	super("See code.");
    }

    /**
     * Creating a fatal exception using the description. 
     *
     * @param desc is the error description.
     */
    public FatalException(String desc) {
	super(desc);
    }

    /**
     * Constructing an fatal exception using an description and a
     * cause exception.
     *
     * @param desc is the description
     * @param cause is the cause exception
     */
    public FatalException(String desc, Throwable cause) {
	super(desc, cause);
    }

}
