
package softparsmap;


/**
 * This class points to a block of bytes in a file. It is used to
 * create indexes.
 */
public class FilePointerPart implements java.io.Serializable {

    private long _pointer = -1;
    private int _length = -1;

    /**
     * An instance needs a pointer which points into the file and
     * how many bytes the block consists of.
     *
     * @param pointer is the pointer
     * @param length is the length of the block
     */
    public FilePointerPart(long pointer, int length) {
	_pointer = pointer;
	_length = length;
    }

    /**
     * Returns the pointer.
     *
     * @return the pointer
     */
    public long getPointer() {
	return _pointer;
    }

    /**
     * Returns the length of the block.
     *
     * @return the length
     */
    public int getLength() {
	return _length;
    }
    
}
