
package softparsmap;


import ooc.*;
import java.util.*;

/**
 * Classes extending this abstract class are used by task {@link ComputeRoot}
 * to choose the preferred gene tree.
 */
public abstract class PreferredTree extends LinkedTagInstance
    implements Comparator {
    
    private GeneNode _freeGeneTree = null;

    private SpeciesNode _speciesTree = null;
  
    //public void setupTagInstance(Tag tag, Object obj1, Object obj2) {
    //	super.setupTagInstance(tag);
    //	_freeGeneTree = (GeneNode)obj1;
    //	_speciesTree = (SpeciesNode)obj2;
    //}

    /**
     * Returns the free gene tree.
     *
     * @return the free gene tree.
     * @see GeneNode
     */
    public GeneNode getFreeGeneTree() {
	return _freeGeneTree;
    }

    public void setFreeGeneTree(GeneNode freeGeneTree) {
	_freeGeneTree = freeGeneTree;
    }

    /**
     * Returns the rooted species tree.
     *
     * @return the rooted species tree.
     * @see SpeciesNode
     */
    public SpeciesNode getSpeciesTree() {
	return _speciesTree;
    }

    public void setSpeciesTree(SpeciesNode speciesTree) {
	_speciesTree = speciesTree;
    }

    /**
     * Returns the data used in the given gene tree that is used
     * to choose the preferred tree.
     *
     * @param geneTree is the given gene tree.
     * @return the data used to choose the preferred tree.
     */
    public abstract String getDesc(GeneNode geneTree);

}
