
package softparsmap;


import java.io.File;
import java.util.*;

/**
 * This program will print a tree. Run to see usage.
 */
public class PrintTree {

    public static void main(String[] args) throws Exception {
	if(args.length!=1) {
	    System.out.println
		("Usage: PrintTree [tree] \n"+
		 "  Try: PrintTree '(((1,2)1.0,3)1.0,4)'");
	    return;
	}
	String geneTree = args[0];
	
	// get gene parser and datasource
	PropertyFile pf = new PropertyFile("softparsmap/def.xml");
	GeneNode gr = null;
	try {
	    gr = (GeneNode)((TreeParser)pf.getTag("tree_parser::newick"))
		.parseIn(geneTree);
	} catch(Exception e1) { try {
	    gr = (GeneNode)((TreeParser)pf.getTag("tree_parser::newick_edge_value"))
		.parseIn(geneTree);
	} catch(Exception e2) { try {
	    gr = (GeneNode)((TreeParser)pf.getTag
		  ("tree_parser::newick_edge_value_leaves_too"))
		.parseIn(geneTree);
	} catch(Exception e3) {
	    throw new FatalException("Tried all existing parsers but faild "+
				     "to parse the gene tree.");
	}}}
	System.out.println(gr.toStringTree());
    }
}
