
package softparsmap;


import ooc.*;
import java.io.*;
import java.util.*;

/**
 * This class will parse the XML property file and give access to
 * its corresponding classes.
 */
public class PropertyFile extends Container {

    /**
     * Construct the instance using a file.
     *
     * @param file is the file
     */
    public PropertyFile(File file) {
	super(file);
    }

    /**
     * Construct the instance from a file in the classpath.
     *
     * @param classpathFile is a file in the classpath.
     */
    public PropertyFile(String classpathFile) {
	super(classpathFile);
    }
    
    /**
     * Returns the task with the given did attribute value. The task
     * must be of the instance {@link AbstractTask} in order for this
     * method to work.
     *
     * @param did is the value of the did attribute of the task tag
     * @param familyGroup is the family group that the task will work on
     * @return the task with the given did
     * @see AbstractTask
     * @see FamilyGroup
     */
    //public Task getTask(String did, FamilyGroup familyGroup) {
    //	return (Task)getTag("task", did).newInstance(familyGroup);
    //}

    /**
     * Returns the data source with the given did attribute value.
     *
     * @param did is the value of the did attribute of the data source tag
     * @return the data source with the given did
     * @see DataSource
     */
    //public DataSource getDataSource(String did) {
    //	return (DataSource)getSingleton("data_source", did);
    //}

    /**
     * Returns the family group with the given did attribute value.
     *
     * @param did is the value of the did attribute of the family group tag
     * @return the family group with the given did
     * @see FamilyGroup
     */
    //public FamilyGroup getFamilyGroup(String did) {
    //	return (FamilyGroup)getSingleton("family_group", did);
    //}

    /**
     * Returns the inparalogous handler with the given did attribute value.
     *
     * @param did is the value of the did attribute of the inparalogous tag
     * @return the inparalogous handler with the given did
     * @see Inparalogous
     */
    //public Inparalogous getInparalogous(String did) {
    //	return (Inparalogous)getSingleton("inparalogous", did);
    //}
    
    /**
     * Returns the edge type with the given did attribute value.
     *
     * @param did is the value of the did attribute of the edge type tag
     * @return the edge type with the given did
     * @see EdgeType
     */
    //public EdgeType getEdgeType(String did) {
    //	return (EdgeType)getSingleton("edge_type", did);
    //}

    /**
     * Returns the tree parser with the given did attribute value.
     *
     * @param did is the value of the did attribute of the tree parser tag
     * @return the tree parser with the given did
     * @see TreeParser
     */
    //public TreeParser getTreeParser(String did) {
    //	return (TreeParser)getSingleton("tree_parser", did);
    //}

    protected EdgeType getEdgeTypeUnknown() {
	return (EdgeType)getTag("edge_type::unknown").getTagInstance();
    }

}
