
package softparsmap;

import ooc.*;

public class StringGeneNodeConverterDupSpe 
    extends StringGeneNodeConverterStringTemplate { 
    
    private String _dupFlag = null;
    private String _speFlag = null;

    public void setupInstance() {
    	super.setupInstance();
	_dupFlag = getAttributeString("duplication_flag");
	_speFlag = getAttributeString("speciation_flag");
    }

    public Node convertCoreToNode(String string, Object info) {
	if (info==null || !(info instanceof GeneNode)) {
	    throw new FatalException
		("Tag "+getTagRef()+": This method only support reading in "+
		 "extra information.");
	}
	GeneNode node = (GeneNode)info;
	if (string.trim().equals(_dupFlag)) {
	    node.setDuplicationsNode(1);
	} else {
	    node.setDuplicationsNode(0);
	}
	return node;
    }
    
    public Node convertCoreToLeaf(String string, Object info) {
	return convertCoreToNode(string, info);
    }

    public String convertCoreFromNode(Node node, Object info) {
	if (((GeneNode)node).getDuplicationsNode()>0) {
	    return _dupFlag;
	} else {
	    return _speFlag;
	}
    }
    
    public String convertCoreFromLeaf(Node leaf, Object info) {	
	return _speFlag;
    }
    
}
