
package softparsmap;

import ooc.*;
import java.util.List;

public class StringGeneNodeConverterSchreiberMapLabel 
    extends StringNodeConverterMapInfo {

    public void beforeParsing(TreeStructureParser tsp, 
			      String treeString, Node tree) {
	super.beforeParsing(tsp, treeString, tree);
	if (!(tsp instanceof TreeStructureParserSchreiber)) {
	    throw new FatalException("Tag "+getTagRef()+": This node "+
				     "converter can only be used by the "+
				     "schreiber tree structure parser.");
	}
	if (tree!=null && !(tree instanceof GeneNode)) {
	    throw new FatalException("Tag "+getTagRef()+": This node "+
				     "converter can only handle gene trees.");
	}
    }

    public void afterParsing(TreeStructureParser tsp, 
			     String treeString, Node tree) {
	List nodes = (List)tree.getMap().get
	    (TreeStructureParserSchreiber.ROOT_NODES_MAP_KEY);
	String label = new Integer(nodes.size()).toString();
	if (isLeaf(tree)) {
	    tree.getMap().put(getLeafKey(), label);
	} else {
	    tree.getMap().put(getNodeKey(), label);
	}
    }
    
}
