
package softparsmap;

import ooc.*;

public class StringNodeConverterMapInfo
    extends StringNodeConverterStringTemplate { 
    
    private String _nodeKey = null;
    private String _leafKey = null;
    private boolean _trim;

    public void setupInstance() {
    	super.setupInstance();
	_nodeKey = getAttributeString("node_key");
	_leafKey = getAttributeString("leaf_key");
	_trim = getAttributeBoolean("trim");
    }

    public String getNodeKey() {
	return _nodeKey;
    }
    
    public String getLeafKey() {
	return _leafKey;
    }

    public Node convertCoreToNode(String string, Object info) {
	return convertCoreToBoth(string, info, _nodeKey);
    }
    
    public Node convertCoreToLeaf(String string, Object info) {
	return convertCoreToBoth(string, info, _leafKey);
    }

    private Node convertCoreToBoth(String string, Object info, String key) {
	if (info==null || !(info instanceof Node)) {
	    throw new FatalException
		("Tag "+getTagRef()+": This method only support reading in "+
		 "extra information.");
	}
	Node node = (Node)info;
	node.getMap().put(key, string);
	return node;
    }
   
    public String convertCoreFromNode(Node node, Object info) {
	return convertCoreFromBoth(node, info, _nodeKey);
    }
    
    public String convertCoreFromLeaf(Node leaf, Object info) {	
	return convertCoreFromBoth(leaf, info, _leafKey);
    }
    
    private String convertCoreFromBoth(Node node, Object info, String key) {
	Object obj = node.getMap().get(key);
	if (obj==null) {
	    throw new FatalException
		("Tag "+getTagRef()+": Could not find a value for the key");
	}
	if (_trim) {
	    return obj.toString().trim();
	} else {
	    return obj.toString().trim();
	}	
    }
    
}
