package softparsmap;

import ooc.*;

public abstract class StringNodeConverterStringTemplate 
    extends AbstractStringNodeConverter {

    private String _markerNode = null;
    private String _markerLeaf = null;
    private StringTemplate _nodeTemplate = null;
    private StringTemplate _leafTemplate = null;

    public void setupInstance() {
	super.setupInstance();
	_markerNode = getAttributeString("marker_node");
	_markerLeaf = getAttributeString("marker_leaf");
	_nodeTemplate = new StringTemplate(getAttributeString("template_node"),
					   getAttributeString("markers_begin"),
					   getAttributeString("markers_end"));
	_leafTemplate = new StringTemplate(getAttributeString("template_leaf"),
					   getAttributeString("markers_begin"),
					   getAttributeString("markers_end"));
    }
    
    public Node convertToNode(String string, Object info) {
	if (string==null) {
	    return convertCoreToNode(null, info);
	}
	_nodeTemplate.paintTemplate(string);
	return convertCoreToNode(_nodeTemplate.getFirstValue(_markerNode), info);
    }
    
    public Node convertToLeaf(String string, Object info) {
	if (string==null) {
	    return convertCoreToLeaf(null, info);
	}
	_leafTemplate.paintTemplate(string);
	return convertCoreToLeaf(_leafTemplate.getFirstValue(_markerLeaf), info);
    }

    public String convertFromNode(Node node, Object info) {
	_nodeTemplate.setMarker(_markerNode, convertCoreFromNode(node, info));
	return _nodeTemplate.getPaintedTemplate();
    }
    
    public String convertFromLeaf(Node leaf, Object info) {
	_leafTemplate.setMarker(_markerLeaf, convertCoreFromLeaf(leaf, info));
	return _leafTemplate.getPaintedTemplate();
    }

    public Node convertCoreToNode(String string, Object info) {
	throw new FatalException
	    ("Tag "+getTagRef()+": Does not support this method.");
    }
    
    public Node convertCoreToLeaf(String string, Object info) {
	throw new FatalException
	    ("Tag "+getTagRef()+": Does not support this method.");
    }

    public String convertCoreFromNode(Node node, Object info) {
	throw new FatalException
	    ("Tag "+getTagRef()+": Does not support this method.");
    }

    public String convertCoreFromLeaf(Node leaf, Object info) {
	throw new FatalException
	    ("Tag "+getTagRef()+": Does not support this method.");
    }

}
