package softparsmap;

import ooc.*;
import java.util.*;

public class TreeStructureParserLeafList extends LinkedTagInstance 
    implements TreeStructureParser {

    protected String _beforeCore = null;
    protected String _afterCore = null;
    protected String _listValueDivider = null;

    public void setupInstance() {
	super.setupInstance();
	_beforeCore = getAttributeString("before_core");
	_afterCore = getAttributeString("after_core");
	_listValueDivider = getAttributeString("list_value_divider");
    }

    public Node parseStructureIn(String tree, StringNodeConverter converter) {
	throw new FatalException
	    ("Tag "+getTagRef()+": This method is not supported.");
    }

    public void parseStructureIn(Node tree, String treeInfo,
				 StringNodeConverter converter) {
	// getting list
	List values = new Vector();
	StringTokenizer st = 
	    new StringTokenizer(getCore(treeInfo), _listValueDivider);
	while (st.hasMoreTokens()) {
	    values.add(st.nextToken());
	}
	// stepping through leaves
	for (Iterator i = tree.getLeaves().iterator();i.hasNext();) {
	    Node node = (Node)i.next();
	    String value = (String)values.get(node.getLabel()-1);
	    converter.convertToNode(value, node);
	}
    }

    // remove any text before and after the core
    private String getCore(String tree) {
	int p0 = tree.indexOf(_beforeCore);
	int p1 = tree.lastIndexOf(_afterCore);
	if (!(p0>-1 && p0<p1)) {
	    throw new FatalException("Can not find the start and end of "+
				     "tree '"+tree+"' when parsing it.");
	}
	return tree.substring(p0+_beforeCore.length(), p1);
    }


    public String parseStructureOut(Node tree, StringNodeConverter converter) {
	// else 
	StringBuffer res = new StringBuffer();
	res.append(_beforeCore);
	// stepping through leaves
	for (Iterator i = tree.getLeaves().iterator();i.hasNext();) {
	    Node node = (Node)i.next();
	    res.append(converter.convertFromNode(node, null));
	    if (i.hasNext()) {
		res.append(_listValueDivider);
	    }
	}
	//
	res.append(_afterCore);
	return res.toString();
    }
  

}
