package softparsmap;

import ooc.*;
import java.util.*;

public class TreeStructureParserSchreiberInfoIn 
extends TreeStructureParserSchreiber {

    public Node parseStructureIn(String tree, StringNodeConverter converter) {
	throw new FatalException("Not supported.");
    }


    public void parseStructureIn(Node tree, String treeInfo,
				 StringNodeConverter converter) {
	// remove any text before and after the core
	String core = getCore(treeInfo);
	// if it is only a leaf
	if (converter.isLeaf(tree)) {
	    return;
	}
	// stepping trough the nodes
	List nodes = (List)tree.getMap().get(ROOT_NODES_MAP_KEY);
	StringTokenizer st = new StringTokenizer(core, _childNodeDivider);
	int i = 0;
	while (st.hasMoreTokens()) {
	    String nodeString = st.nextToken();
	    converter.convertToNode(nodeString, nodes.get(i));
	    i++;
	}
    }


    public String parseStructureOut(Node tree, StringNodeConverter converter) {
	// if the tree is a leaf
	if (converter.isLeaf(tree)) {
	    return _left + _right;
	}
	// else 
	StringBuffer res = new StringBuffer();
	res.append(_beforeCore);
	if (tree.hasChildren()) {
	    parseStructureOut(tree, res, new Hashtable(), 1, converter);
	}
	res.append(_afterCore);
	return res.toString();
    }
    protected int parseStructureOut(Node node, StringBuffer tree, 
				    Map nodeToNumber, int nextNumber, 
				    StringNodeConverter converter) {
	// if leaf, do nothing
	if (!node.hasChildren()) {
	    return nextNumber;
	}
	// deep first
	for (Iterator i = node.getChildren().iterator();i.hasNext();) {
	    nextNumber = parseStructureOut
		((Node)i.next(), tree, nodeToNumber, nextNumber, converter);
	}
	// building string for one internal node
	tree.append(converter.convertFromNode(node, null));
	if (!node.isRoot()) {
	    tree.append(_nodeDivider);
	}
	// adding this node to the map
	nodeToNumber.put(node, new Integer(nextNumber));
	nextNumber++;
	//
 	return nextNumber;
    }

}
