
package softparsmap;


import java.util.*;

/**
 *  A help class to print trees in an easy to understand format.
 */
public class TreeTextBlock {

    private List rows;
    private List nodes;
    private Node node;  
    private final int layer = 2;

    public TreeTextBlock(Node node) {
	init(node);
	nodes().add(node);
	rows().add("-"); //rep("-",layer));
    }
    public TreeTextBlock(List allTtb, Node n) {
	init(n);
	int maxNumCols = 0;
	for(Iterator i=allTtb.iterator();i.hasNext();) {
	    TreeTextBlock ttb = (TreeTextBlock)i.next();
	    if(ttb.numCols()>maxNumCols) {
		maxNumCols = ttb.numCols()+ttb.ei().length();
	    }
	}
	//System.out.println("** n: " + n);
	//System.out.println("** maxNumCols: " + maxNumCols);
	for(Iterator i=allTtb.iterator();i.hasNext();) {
	    TreeTextBlock ttb = (TreeTextBlock)i.next();
	    this.addBlockUnder(ttb, maxNumCols,i.hasNext());
	}
    }
   
    private void init(Node node) {
	this.nodes = new Vector();
	this.rows = new Vector();
	this.node = node;
    }
    
    private String ei() {
	return "(" + this.node.getLabel() + ")";
	//return this.node.toStringTreeNodeInfo();
    }
    
    private String l(int nc, TreeTextBlock ttb) {
	return "|" + rep(" ",nc+layer+ttb.ei().length());
    }
    //    private String rf(int nc, TreeTextBlock ttb) {
    //	return "/"+rep("-",nc+layer) + ttb.ei();
    //    }
    private String rm(int nc, TreeTextBlock ttb) {
	return "+"+rep("-",nc+layer) + ttb.ei();
    }
    //    private String rl(int nc, TreeTextBlock ttb) {
    //	return "\\"+rep("-",nc+layer) + ttb.ei();
    //    }    
    private String b(int nc, TreeTextBlock ttb) {
	return rep(" ",1+nc+layer+ttb.ei().length());
    }
    
    private String rep(String rs, int n) {
	StringBuffer sb = new StringBuffer();
	for(int i=0;i<n;i++) {
	    sb.append(rs);
	}
	return sb.toString();
    }
    
    private void addBlockUnder(TreeTextBlock ttb, int maxNumCols,
			       boolean nextExists) {
	int nc = maxNumCols-ttb.numCols()-ttb.ei().length();
	//System.out.println("*** nc: " + nc);
	if(rows().isEmpty()) {
	    for(int i=0;i<ttb.numRows();i++) {
		//System.out.println("************** rows(): " + rows());
		if(i<ttb.rootAtRow()) {
		    rows().add(b(nc,ttb) + ttb.rows().get(i));
		} else if(i==ttb.rootAtRow()) {
		    rows().add(rm(nc,ttb) + ttb.rows().get(i));
		} else {
		    rows().add(l(nc,ttb)  + ttb.rows().get(i));
		}
		nodes().add(ttb.nodes().get(i));
	    }	    
	} else {
	    for(int i=0;i<ttb.rows().size();i++) {
		if(i<ttb.rootAtRow()) {
		    rows().add(l(nc,ttb) + ttb.rows().get(i));
		} else if(i==ttb.rootAtRow()) {
		    rows().add(rm(nc,ttb) + ttb.rows().get(i));
		} else {
		    if(nextExists) {
			rows().add(l(nc,ttb) + ttb.rows().get(i));
		    } else {
			rows().add(b(nc,ttb) + ttb.rows().get(i));
		    }
		}
		nodes().add(ttb.nodes().get(i));		
	    }
	}
	if(nextExists) {
	    nodes().add(null);
	    rows().add("|");
	}

    }

    public String toString() {
	StringBuffer sb = new StringBuffer();
	String ni = ei();
	for(int i=0;i<numRows();i++) {
	    if(i!=rootAtRow()) {
		sb.append(rep(" ",ni.length()));
	    } else {
		sb.append(ni);
	    }
	    sb.append(row(i));
	    if(nodes().get(i)!=null) {
		//sb.append(((Node)nodes().get(i))
		//.toStringTreeNodeInfo());
	    }
	    sb.append("\n");
	}
	return sb.toString();
    }
    
    private List rows() {
	return this.rows;
    }

    private List nodes() {
	return this.nodes;
    }

    private int numRows() {
	return rows().size();
    }

    private String row(int r) {
	if(numRows()>0) {
	    return (String)rows().get(r);
	}
	return null;
    }

    private int rootAtRow() {
	return numRows()/2;
    }
    
    private int numCols() {
	if(numRows()>0) {
	    return row(0).length();
	}
	return -1;
    }

    
	    
}
