
package softparsmap.tests;


import java.util.*;
import java.io.*;
import softparsmap.*;
import junit.framework.*;

public class TestNodeSLeafS extends CommonTestCase {

    public static void main(String[] args) {
	junit.textui.TestRunner.run(suite());
    }

    public static Test suite() {
	return new TestSuite(TestNodeSLeafS.class);
    }

    public void testDuplications() throws IOException  {
	GeneNode ge,g;
	SpeciesNode sp,s;
	int dup, gen;
	List trees;

	// added 2004-01-26
	g = bin(bin(bin(bin(bin(bin(5,6),7),3),4),1),2);
	setEdgeInSubTree(g,0.1);

	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(5).addSequence(null,6));
	s = binS(s,3);
	s = binS(s,4);
	s = binS(s,7);
	dups(s, g, true);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("\nSpecies: \n"+s.toStringAll());
	//System.out.println("Gene: \n"+g.toStringAll());
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==0);
	
	
	// extra case 2004-01-22, gene loss 
	s = (SpeciesNode)triS
	    (nextLeafS(1).addSequence(null,2).addSequence(null,5),
	     nextLeafS(3).addSequence(null,6), nextLeafS(4));
	g = tri(newLeaf(1), bin(newLeaf(4),bin(5,6)),
		     bin(2,3));
	dups(s, g);
	//dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	//System.out.println("\n"+s.toStringTree());
	//System.out.println(g.toStringAll());
	Assert.assertTrue(dup==2 && gen==2);
	
	// added 2004-10-07
	g = bin(bin(bin(bin(bin(bin(5,6),7),3),4),1),2);
	setEdgeInSubTree(g,0.1);

	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(5).addSequence(null,6));
	s = binS(s,3);
	s = binS(s,4);
	s = binS(s,7);
	dups(s, g, true);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("\nSpecies: \n"+s.toStringAll());
	//System.out.println("Gene: \n"+g.toStringAll());
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==0);
	
	// extra case 2004-01-23, gene loss 
	s = (SpeciesNode)triS
	    (nextLeafS(1).addSequence(null,2).addSequence(null,3),
	     nextLeafS(4).addSequence(null,5), nextLeafS(6));
	g = (GeneNode)tri(1,2,3).addChild(newLeaf(4)).addChild(newLeaf(5))
	    .addChild(newLeaf(6));
	//dups(s, g);
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("\nSpecies: \n"+s.toStringAll());
	//System.out.println("Gene: \n"+g.toStringAll());
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==0);
	
	// extra case 2003-03-25, gene loss 
	s = (SpeciesNode)triS(binS(binS(7,8),5), nextLeafS(6),
			      nextLeafS(4)).addChild(nextLeafS(1)
						     .addSequence(null,2)
						     .addSequence(null,3));
	s = binS(binS(binS(9,10),11),s);
	g = bin(bin(bin(2,3),bin(7,8)),
		     bin(bin(9,10),1));
	g = bin(bin(bin(bin(5,6),4),11),g);

	dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());

	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==3 && gen==8);

	
	// extra case 2003-03-25, gene loss 
	s = binS(binS(1,5),triS(nextLeafS(3),
				nextLeafS(7),
				triS(2,6,8)));
	g =(GeneNode)tri(newLeaf(7),bin(1,5),newLeaf(2))
	    .addChild(newLeaf(3)).addChild(bin(8,6));
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==0 && gen==0);

	// extra case 2003-03-25, gene loss 
	s = (SpeciesNode)triS(triS(17,18,19), nextLeafS(20),
			     nextLeafS(15).addSequence(null,16)
			     .addSequence(null,21).addSequence(null,22));
	g = tri(bin(17,18),
		     bin(bin(bin(bin(15,16),21),22),20),
		     newLeaf(19));
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==3 && gen==0);

	// extra case 2003-03-24, gene loss #1
	s = (SpeciesNode)triS(nextLeafS(14),nextLeafS(13),
			     nextLeafS(1).addSequence(null,2))
	    .addChild(binS(binS(11,12),nextLeafS(10)));
	s = binS(binS(s,nextLeafS(15)),nextLeafS(16));
	g = (GeneNode)bin(14,1).addChild(bin(10,bin(11,12)));
	g = bin(tri(g,bin(2,13),newLeaf(15)),16);
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==2);

	// extra case 2003-03-19, gene loss
	s = triS(binS(binS(binS(3,5), nextLeafS(4)),
				nextLeafS(2)), nextLeafS(1),
		      binS(6,7));
	s.addChild(binS(8,9));
	g = bin(bin(1,2), bin(bin(6,7),5));
	g = bin(g, bin(bin(8,9),bin(3,4)));
	dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==10);

	
	// extra case 2003-03-19, gene loss
	s = triS(binS(binS(binS(3,5), nextLeafS(4)),
				nextLeafS(2)), nextLeafS(1),
		      binS(6,7));
	s.addChild(binS(8,9));

	g = tri(bin(1,2), bin(bin(6,7),5),
		     bin(bin(8,9),bin(3,4)));
	dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==10);

	// extra case 2003-03-18, gene loss
	s = binS(nextLeafS(10),
		      triS(nextLeafS(6).addSequence(null,7)
				.addSequence(null,8),nextLeafS(9),
				nextLeafS(1).addSequence(null,2)
				.addSequence(null,3).addSequence(null,4)
				.addSequence(null,5)));
	g = tri(bin(6,4), newLeaf(7), newLeaf(8));
	g.addChild(bin(3,9));
	g.addChild(bin(5,10));
	g.addChild(bin(1,2));	
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==4 && gen==3);


	
	// extra case 2003-03-17, gene loss
	s = binS(triS(nextLeafS(1).addSequence(null,3),
				nextLeafS(4), nextLeafS(2)),
		      nextLeafS(5));
	g = tri(bin(1,2), bin(3,4), newLeaf(5));
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==2);
	// extra case 2003-03-17, gene loss
	s = binS(nextLeafS(1).addSequence(null,5), 
		      nextLeafS(2).addSequence(null,6));
	s = binS(binS(s, nextLeafS(3)),nextLeafS(4));
	g = bin(1,2);
	g = (GeneNode)g.addChild(newLeaf(3));
	g = (GeneNode)g.addChild(newLeaf(4));
	g = (GeneNode)g.addChild(newLeaf(5));
	g = (GeneNode)g.addChild(newLeaf(6));
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==0);

	    
	// extra case 2003-03-17, gene loss
	s = binS(nextLeafS(2).addSequence(null,3).addSequence(null,5),
		      nextLeafS(7).addSequence(null,10));
	s = binS(binS(s, nextLeafS(11)),nextLeafS(12));
	g = bin(bin(2,12),3);
	g = (GeneNode)g.addChild(newLeaf(5));
	g = (GeneNode)g.addChild(newLeaf(7));
	g = (GeneNode)g.addChild(newLeaf(10));
	dups(s, g);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==4);


	// extra case 2003-03-06, gene loss
	s = binS(binS(nextLeafS(1),
				nextLeafS(2).addSequence(null,3)
				.addSequence(null,4)),
		      nextLeafS(5));
	g = tri(newLeaf(5), bin(3,1),bin(4,2));
	//g = tri(bin(4,2),bin(3,1),newLeaf(5));	
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());	
	dups(s, g);		
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==1);
	
	// extra case 2003-03-06, gene loss	
	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(3).addSequence(null,4).addSequence(null,5));
	g = bin(bin(bin(bin(3,4),5),1),2);
	((GeneNode)g.findLeaf(1).getParent()).setEdgeValue(0.1);
	dups(s, g);		
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());	
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==3 && gen==0);
	// extra case 2003-03-05, gene loss
	s = binS(binS(nextLeafS(1),
				nextLeafS(3).addSequence(null,5)),
		      nextLeafS(8));
	s = binS(nextLeafS(18).addSequence(null,19),s);
	s = binS(nextLeafS(16),s);	
	g = tri(bin(3,5),newLeaf(1),newLeaf(8));
	g.addChild(newLeaf(16));
	dups(s, g);	
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==1 && gen==1);
	// extra case 2003-03-05, gene loss
	s = triS(binS(1,3), nextLeafS(2).addSequence(null,5) ,
		      nextLeafS(4).addSequence(null,6));
	g = tri(bin(1,2),bin(3,4),bin(5,6));
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());		
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println("dup: "+dup+", gen: "+gen);
	Assert.assertTrue(dup==2 && gen==5);
	
	// extra case 2003-03-05, gene loss	
	s = binS(binS(binS(2,1),nextLeafS(3)),
		      nextLeafS(4));
	g = bin(bin(1,3),bin(2,4));
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());		
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	Assert.assertTrue(dup==1 && gen==4);
	
	// extra case 2003-03-03, gene loss
	s = binS(binS(3,4),nextLeafS(1).addSequence(null,2));
	g = bin(bin(1,4),bin(2,3));
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());		
	Assert.assertTrue(dup==1 && gen==2);
	
	// extra case 2003-03-03
	s = triS(binS(nextLeafS(1),nextLeafS(3)),
		      nextLeafS(2).addSequence(null,5),
		      nextLeafS(4).addSequence(null,6));
	g = tri(bin(1,2),bin(3,4),bin(5,6));
	dup = dups(s, g);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	
	// binara arttrd med flera gen sekvenser
	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(3).addSequence(null,4).addSequence(null,5));
	//  (1,2,3,4,5):D2
	g = (GeneNode)tri(1,2,3).addChild(newLeaf(4)).addChild(newLeaf(5));
	dup = dups(s, g);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent())
			  .getDuplicationsNode()==2);
	//  (((1,4):S,5):D1,2,3):D1, Not weak
	g = tri(bin(5,bin(1,4)),newLeaf(2),newLeaf(3));
	dup = dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());	
	Assert.assertTrue(g.countGeneLosses()==1);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent())
			  .getDuplicationsNode()==0);
	Assert.assertTrue(((GeneNode)g.findLeaf(5).getParent())
			  .getDuplicationsNode()==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(2).getParent())
	                  .getDuplicationsNode()==1);


	//  added 2004-01-24
	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(3).addSequence(null,4).addSequence(null,5));
	g = (GeneNode)tri(bin(1,4),newLeaf(2),newLeaf(3))
	    .addChild(newLeaf(5));
	dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	Assert.assertTrue(g.countDuplications()==2 &&
			  g.countGeneLosses()==0);
	
	//  (((1,4):S,5):D1,2,3):D1, weak
	s = binS(nextLeafS(1).addSequence(null,2),
		      nextLeafS(3).addSequence(null,4).addSequence(null,5));
	g = tri(bin(5,bin(1,4)),newLeaf(2),newLeaf(3));
	((GeneNode)g.findLeaf(5).getParent()).setEdgeValue(0.1);
	dup = dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(g.countGeneLosses()==0);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent())
			  .getDuplicationsNode()==0);
	Assert.assertTrue(((GeneNode)g.findLeaf(2).getParent())
			  .getDuplicationsNode()==2);

	//  (((1,2,3):D1,(4,5):D1):D1
	g = bin(tri(1,2,3),bin(4,5));
	dup = dups(s, g);
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	Assert.assertTrue(dup==3 && g.countDuplications()==dup);
	Assert.assertTrue(g.countGeneLosses()==1);	
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent())
			  .getDuplicationsNode()==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(2).getParent().getParent())
			  .getDuplicationsNode()==1);
	//  (((1,2,3,4):D2,5):D1
	g = bin((GeneNode)tri(1,2,3).addChild(newLeaf(4)),5);
	dup = dups(s, g);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(5).getParent()).getDuplicationsNode()
			  ==1);

	//  (((1,2):D1,3,4):D1,5):D1
	g = bin(tri(bin(1,2),newLeaf(3),newLeaf(4)),5);
	dup = dups(s, g);
	Assert.assertTrue(dup==3 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(3).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(5).getParent()).getDuplicationsNode()
			  ==1);
	// a) ((((4,5):D,3):D,1):S,2):D
	s = binS(nextLeafS(1).addSequence(null,2),
		 nextLeafS(3).addSequence(null,4).addSequence(null,5));
	g = bin(bin(bin(bin(4,5),3),1),2);
	dup = dups(s, g);
	Assert.assertTrue(dup==3 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(3).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(2).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent()).getDuplicationsNode()
			  ==0);
	Assert.assertTrue(((GeneNode)g.findLeaf(4).getParent()).getDuplicationsNode()
			  ==1);
	// b) ((((4,5):D,1):S,2):D,3):D
	g = bin(bin(bin(bin(4,5),1),2),3);
	dup = dups(s, g);
	Assert.assertTrue(dup==3 && g.countDuplications()==dup);
	Assert.assertTrue(((GeneNode)g.findLeaf(4).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(2).getParent()).getDuplicationsNode()
			  ==1);
	Assert.assertTrue(((GeneNode)g.findLeaf(1).getParent()).getDuplicationsNode()
			  ==0);
	Assert.assertTrue(((GeneNode)g.findLeaf(3).getParent()).getDuplicationsNode()
			  ==1);

	    
	// binra arttrd och gentrd med svaga grenar
	s = binS(binS(binS(1,2),3),4);
	g = bin(bin(bin(4,3),newLeaf(2)),newLeaf(1));
	((GeneNode)g.findLeaf(3).getParent()).setEdgeValue(0.1);

	//System.out.println("\n"+s.toStringTree());
	//	System.out.println(g.toStringTree());
	
	Assert.assertTrue(dups(s, g, false)==2);
	Assert.assertTrue(g.countGeneLosses()==7);
	Assert.assertTrue(g.getDuplicatedNodes().size()==2);
	Assert.assertTrue(g.collapsedEdges().size()==0);

	s = binS(binS(binS(1,2),3),4);
	//	s = bin(bin(bin(1,2),newLeaf(3)),newLeaf(4));
	g = bin(bin(bin(4,3),newLeaf(2)),newLeaf(1));
	((GeneNode)g.findLeaf(3).getParent()).setEdgeValue(0.1);
	//System.out.println(s.toStringAll());
	//System.out.println(g.toStringAll());
	//System.out.println(s.toStringTree());
	//System.out.println(g.toStringTree());
	dup = dups(s, g);
	//System.out.println(g.toStringTree());	
	Assert.assertTrue(dup==1);
	Assert.assertTrue(g.countGeneLosses()==4);
	Assert.assertTrue(g.getDuplicatedNodes().size()==1);
	Assert.assertTrue(g.collapsedEdges().size()==1);

	s = binS(binS(binS(1,2),3),4);
	//	s = bin(bin(bin(1,2),newLeaf(3)),newLeaf(4));
	g = bin(bin(bin(4,3),newLeaf(2)),newLeaf(1));
	((GeneNode)g.findLeaf(2).getParent()).setEdgeValue(0.1);
	Assert.assertTrue(dups(s, g)==1);
	Assert.assertTrue(g.getDuplicatedNodes().size()==1);
	Assert.assertTrue(g.collapsedEdges().size()==1);
	s = binS(binS(binS(1,2),3),4);
	//	s = bin(bin(bin(1,2),newLeaf(3)),newLeaf(4));
	g = bin(bin(bin(4,3),newLeaf(2)),newLeaf(1));
	((GeneNode)g.findLeaf(2).getParent()).setEdgeValue(0.1);
	((GeneNode)g.findLeaf(3).getParent()).setEdgeValue(0.1);
	Assert.assertTrue(dups(s, g)==0);
	Assert.assertTrue(g.getDuplicatedNodes().size()==0);
	Assert.assertTrue(g.collapsedEdges().size()==2);

	// varken binra gentrd eller binra arttrd
	sp = triS(nextLeafS(1),nextLeafS(2),
		      binS(3,binS(4,5)));
	ge = tri(newLeaf(1),newLeaf(3),bin(bin(4,5),2));
	Assert.assertTrue(dups(sp, ge)==1);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==1);
	Assert.assertTrue(ge.countDuplications()==1);

	sp = triS(nextLeafS(1),nextLeafS(2),
		      binS(3,binS(4,5)));
	ge = bin(newLeaf(3),bin(newLeaf(1),bin(newLeaf(2),bin(4,5))));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==1);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==1);
	Assert.assertTrue(ge.countDuplications()==ge.getDuplicatedNodes().size());
	sp = triS(binS(1,2),binS(3,4),nextLeafS(5));
	ge = bin(newLeaf(5),bin(bin(1,3),bin(2,4)));
	Assert.assertTrue(dups(sp, ge)==1);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==1);
	Assert.assertTrue(ge.countDuplications()==ge.getDuplicatedNodes().size());
	ge = tri(newLeaf(5),bin(1,3),bin(2,4));
	dup = dups(sp, ge);
	//System.out.println("\n"+sp.toStringAll());
	//System.out.println("\n"+ge.toStringAll());
	//System.out.println("dup: "+dup);
	//System.out.println("count dup: "+g.countDuplications());
	Assert.assertTrue(dup==1);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==1);
	//	System.out.println(sp.toStringAll());
	//	System.out.println(ge.toStringAll());
	//System.out.println(ge.countDuplications());
	//	System.out.println(ge.getDuplicatedNodes().size());
	Assert.assertTrue(ge.countDuplications()==ge.getDuplicatedNodes().size());
	sp = triS(binS(1,2),binS(3,4),nextLeafS(5));
	//ge = tri(newLeaf(4),bin(3,2),bin(5,1));
	ge = bin(bin(3,2),bin(4,bin(5,1)));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==1 && ge.countDuplications()==dup);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==1);
	Assert.assertTrue(dups(triS(1,2,3), tri(1,2,3))==0);
	// binra gentrd men ej binrt arttrd
	sp = (SpeciesNode)nextNodeS().addChild(binS(1,2)).
	    addChild(binS(3,4)).addChild(nextLeafS(5));
	ge = bin(bin(bin(1,3),newLeaf(2)),bin(4,5));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==2 && ge.countDuplications()==dup);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==2);
	sp = binS(4,(SpeciesNode)nextNodeS().addChild(nextLeafS(1))
		  .addChild(nextLeafS(2)).addChild(nextLeafS(3)));
	ge = bin(bin(bin(1,2),newLeaf(3)),newLeaf(4));
	g = ge.cloneTree().findLeaf(newLeaf(4)).reroot();
	dup = dups(sp, g);
	Assert.assertTrue(dup==0 && g.countDuplications()==dup);
	Assert.assertTrue(g.getDuplicatedNodes().size()==0);
	g = ge.cloneTree().findLeaf(newLeaf(1)).reroot();
	dup = dups(sp, g);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(g.getDuplicatedNodes().size()==2);
	g = ge.cloneTree().findLeaf(newLeaf(3)).reroot();
	dup = dups(sp, g);
	Assert.assertTrue(dup==1 && g.countDuplications()==dup);
	Assert.assertTrue(g.getDuplicatedNodes().size()==1);
	g = ge.cloneTree().findLeaf(newLeaf(2)).reroot();
	dup = dups(sp, g);
	Assert.assertTrue(dup==2 && g.countDuplications()==dup);
	Assert.assertTrue(g.getDuplicatedNodes().size()==2);
	sp = (SpeciesNode)nextNodeS().addChild(nextLeafS(1))
	    .addChild(nextLeafS(2)).addChild(nextLeafS(3));
	ge = bin(bin(1,2),newLeaf(3));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==0 && ge.countDuplications()==dup);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==0);
	ge = bin(bin(1,3),newLeaf(2));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==0 && ge.countDuplications()==dup);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==0);
	ge = bin(bin(2,3),newLeaf(1));
	dup = dups(sp, ge);
	Assert.assertTrue(dup==0 && ge.countDuplications()==dup);
	Assert.assertTrue(ge.getDuplicatedNodes().size()==0);

    }

    public int dups(SpeciesNode s, GeneNode g) {
	Mutation mut = s.inferMutation(g, true, null);
	return mut.getDuplication();
    }

    public int dups(SpeciesNode s, GeneNode g, boolean collapse) {
	Mutation mut = s.inferMutation(g, collapse, null);
	return mut.getDuplication();
    }

    
    public void testMinimizeMutationDivide() {

	// weak edges under the roots should be collapsed
	
	SpeciesNode s;
	GeneNode g;
	Mutation mut;
	EdgeType di = (EdgeType)pf.getTag("edge_type::divide").getTagInstance();
	//System.out.println("*** di: "+((StandardEdgeType)di).toStringAll());
	
	// 2004-12-10
	s = SpeciesNode.parseNewick(ds, "((((1),(2)),(3)),(4))");
	g = parseNewickNe(di, "((1,3),(2,4))");
	((GeneNode)g.findLeaf(1).getParent()).setEdgeValue(0.5);
	((GeneNode)g.findLeaf(2).getParent()).setEdgeValue(0.5);
	//System.out.println(g.toStringAll());
	
	mut = s.inferMutation(g, true, null);
	//System.out.println("\n"+s.toStringAll());
	//System.out.println(g.toStringAll());

	Assert.assertTrue(mut.getDuplication()==0);
	Assert.assertTrue(mut.getLoss()==0);

    }

    /*
    public void testCountMutation() {
	SpeciesNode s;
	GeneNode g;
	Mutation mut;
	
	// 2004-12-09
	Inparalogous inCount = pf.getInparalogous("count_mutation");
	Inparalogous inDoNotCount =
	    pf.getInparalogous("do_not_count_mutation");
	// binary gene tree
	s = SpeciesNode.parseNewick(ds, "((1,2,4),(3))");
	g = parseNewickNe(et, "(((1,2),3),4)");
	// count
	mut = s.inferMutation(g, false, inCount);
	Assert.assertTrue(mut.getDuplication()==2);
	Assert.assertTrue(mut.getLoss()==1);
	// not count
	mut = s.inferMutation(g, false, inDoNotCount);
	Assert.assertTrue(mut.getDuplication()==1);
	Assert.assertTrue(mut.getLoss()==1);
	
	// non binary gene tree
	s = SpeciesNode.parseNewick(ds, "((1,2,4),(3))");
	g = parseNewickNe(et, "((1,2),3,4)");
	// count
	mut = s.inferMutation(g, false, inCount);
	Assert.assertTrue(mut.getDuplication()==2);
	Assert.assertTrue(mut.getLoss()==0);
	// not count
	mut = s.inferMutation(g, false, inDoNotCount);
	Assert.assertTrue(mut.getDuplication()==1);
	Assert.assertTrue(mut.getLoss()==0);

	// non binary but weak edge and can collapse
	s = SpeciesNode.parseNewick(ds, "((1,2,4),(3))");
	g = parseNewickNe(et, "(((1,2),3),4)");
	((GeneNode)g.findLeaf(3).getParent()).setEdgeValue(0.001);
	// count
	mut = s.inferMutation(g, true, inCount);
	Assert.assertTrue(mut.getDuplication()==2);
	Assert.assertTrue(mut.getLoss()==0);
	// not count
	mut = s.inferMutation(g, true, inDoNotCount);
	Assert.assertTrue(mut.getDuplication()==1);
	Assert.assertTrue(mut.getLoss()==0);
    }
    */

    
    public void testParseSpeciesTree() {
	String textSpe = "((1,2),((3,4),(5,6)))";
	SpeciesNode s = SpeciesNode.parseNewick(ds, textSpe);

	Assert.assertEquals(textSpe, s.toNewick());

	//System.out.println(s.toStringAll());
	//System.out.println(s.toNewick());
	
    }

    
    public void testInsertSpeciesTreeSplits() {
	GeneNode n;
	SpeciesNode s;
	SpeciesLeaf sl;
	
	// dont know when
	sl = nextLeafS(4);
	sl.addSequence(newLeaf(5));
	s = binS(triS(1,2,3), sl);
	n = (GeneNode)tri(1,2,3).addChild(newLeaf(4))
	    .addChild(newLeaf(5));

	//System.out.println(s.toStringAll());
	//System.out.println(n.toStringAll());
	
	dups(s, n);
	n.insertSpeciesTreeSplits();

	//System.out.println(n.toStringAll());
	
	Assert.assertTrue( n.findLeaf(1).getParent().numChildren()==3 );
	Assert.assertTrue( n.findLeaf(2).getParent().numChildren()==3 );
	Assert.assertTrue( n.findLeaf(3).getParent().numChildren()==3 );
	Assert.assertTrue( n.findLeaf(4).getParent().numChildren()==2 );
	Assert.assertTrue( n.findLeaf(5).getParent().numChildren()==2 );
    }
    
    public void testLca_set() {
	SpeciesNode s, s1, s2, s3;
	// found 2003-04-22
	s2 = binS(4, binS(2,3));
	s1 = nextLeafS(1);
	s3 = binS((SpeciesNode)triS(5,6,7).addChild(nextLeafS(8)),
		       nextLeafS(9) );
	s = binS(binS(s1,nextLeafS(10)), binS(11,12));
	s = binS(s,binS(binS(s2,s3),nextLeafS(13)));
	s.setPreorder();
	//System.out.println(s.toStringTree());
	Set spec = new HashSet();
	spec.add(s1);
	spec.add(s2);	
	spec.add(s3);

	Assert.assertTrue(SpeciesNode.computeLca(spec).equals(s));
    }
    
    public void testPreorderAbove() {
	SpeciesNode nt,n,n1,n2,n3,n4,n5,n6,n7,n8,n9;
	SpeciesLeaf l1,l2,l3,l4,l5;

	// found 2003-09-22
	l1 = new SpeciesLeaf(null,1);
	l2 = new SpeciesLeaf(null,2);
	l3 = new SpeciesLeaf(null,3);
	l4 = new SpeciesLeaf(null,4);
	l5 = new SpeciesLeaf(null,5);
	n = binS(binS(l1,l2),binS(l3,binS(l4,l5)));
	n.setPreorder();
	//	System.out.println("\n"+n.toStringAll());  
	Assert.assertTrue( !((SpeciesNode)l2.getParent()).isBelow
			   ((SpeciesNode)l5.getParent()));
	Assert.assertTrue( !((SpeciesNode)l5.getParent()).isBelow
			   ((SpeciesNode)l2.getParent())  );	

	/*
	// found erlier
	n1 = new SpeciesNode(null,1);
	n2 = new SpeciesNode(null,2);
	n3 = new SpeciesNode(null,3);
	n4 = new SpeciesNode(null,4);
	n5 = new SpeciesNode(null,5);
	n = binS(n1,triS(n2,n3,binS(n4,n5)));
	n.setPreorder();
	nt = n;
	//System.out.println("in: " + nt.poIn() + ", out: " + nt.poOut());
	//Assert.assertTrue(nt.poIn()==1 && nt.poOut()==9);
	nt = n1;
	//Assert.assertTrue(nt.poIn()==2 && nt.poOut()==3);
	nt = n2;
	//Assert.assertTrue(nt.poIn()==4 && nt.poOut()==5);
	nt = n3;
	//Assert.assertTrue(nt.poIn()==5 && nt.poOut()==6);
	nt = n4;
	//Assert.assertTrue(nt.poIn()==7 && nt.poOut()==8);
	nt = n5;
	//Assert.assertTrue(nt.poIn()==8 && nt.poOut()==9);
	nt = (SpeciesNode)n2.getParent();
	//Assert.assertTrue(nt.poIn()==3 && nt.poOut()==9);
	nt = (SpeciesNode)n4.getParent();
	//Assert.assertTrue(nt.poIn()==6 && nt.poOut()==9);
	// above
	Assert.assertTrue(n.isBelow(n1));
	Assert.assertTrue(!n.isBelow(n));
	Assert.assertTrue(!n1.isBelow(n));
	//Assert.assertTrue(n1.inSubTreeOf(n));
	//Assert.assertTrue(n.inSubTreeOf(n));
	//Assert.assertTrue(!n.inSubTreeOf(n1));
	*/
    }

    /*
    public void testReduceMaxDegree() {
	SpeciesNode s;
	GeneNode g,ng;
	int dup,gen;
	BoardHolder bh;
	
	// 2004-01-25
	s = binS(nextLeafS(1).addSequence(null,2).addSequence(null,3),
		      nextLeafS(4).addSequence(null,5).addSequence(null,6) );

	g = (GeneNode)tri(1,2,3).addChild(newLeaf(4)).addChild(newLeaf(5))
	    .addChild(newLeaf(6));
	dups(s, g);
	dup = g.countDuplications();
	gen = g.countGeneLosses();
	bh = new BoardHolder(g, g.children().iterator());
	bh.resolveToMaxDegree(2);
	dups(s, g);
	Assert.assertTrue(g.binaryTree());
	Assert.assertTrue(dup==g.countDuplications() &&
			  gen==g.countGeneLosses());
    }
    */

    public void setEdgeInSubTree(GeneNode n, double d) {
	n.setEdgeValue(d);
	if(n.hasChildren()) {
	    for(Iterator i = n.getChildren().iterator();i.hasNext();) {
		setEdgeInSubTree((GeneNode)i.next(),d);
	    }
	}
    }
    
}
